#include <bits/stdc++.h>

using namespace std;

string okreni(string s)
{
    int n = s.length();

    for (int i = 0; i < n / 2; i++)
        swap(s[i], s[n - i - 1]);

    return s;
}

int fun(string s)
{
    int n = s.length();
    int br = 0;

    for (int i = 0; i < n / 2; i++) {
        int l = i;
        int r = n-l-1;

        while (l < r){
            if (s[l] == s[r])
                break;
            else
                r--;
        }

        if (l == r){
            return -1;
        }

        for (int j = r; j<n-l-1; j++){
            swap(s[j], s[j+1]);
            br++;
        }
    }

    return br;
}

int main()
{
    string t;
    cin >> t;

    int res=max(fun(t), fun(okreni(t)));
    if(res==0)
        cout << res+1;
    else
        cout << res;
    return 0;
}